package jpa.test.persistencexml;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;

import jpa.test.client.ClientJPABase;
import jpa.test.persistencexml.entity.EntityClass;

public class Client extends ClientJPABase
{
    public Client() {}

    public void testMethod()
    {
        EntityManagerFactory emf = null;
        EntityManager em = null;

        testStart("persistence.xml-test");
        try
        {
            setPersistenceUnitName("em1");
            emf = getEntityManagerFactroy();
            em = getEntityManager();

            log(("EMF State : open ->" + emf.isOpen()));
            log(("EM State : open ->" + em.isOpen()));
            assertTrue(emf.isOpen());
            assertTrue(em.isOpen());

            transactionBegin();

            EntityClass entity = new EntityClass();
            entity.id = "Test001";
            entity.detail = "PersistenceTest";

            em.persist(entity);

            transactionCommit();

            emf.close();

            log(("EMF State : open ->" + emf.isOpen()));
            log(("EM State : open ->" + em.isOpen()));
            assertFalse(emf.isOpen());
            assertFalse(em.isOpen());

            cleanup();

            em = getEntityManager();

            transactionBegin();
            entity = em.find(EntityClass.class,"Test001");
            
            assertEquals("PersistenceTest",entity.detail);

            em.remove(entity);
            transactionCommit();
        }
        catch(Throwable thw)
        {
            failed("unexpected error occurred" + thw.toString());
            thw.printStackTrace();
        }
        finally
        {
            testEnd();
        }
    }
    
    public static void main(String[] args)
    {
        Client client = new Client();
        client.testMethod();
    }

}
